]> git.pld-linux.org Git - packages/apache.git/blobdiff - apache.init
- whitespace cleanup
[packages/apache.git] / apache.init
index e2448a60f8d5f64e9400fb6d10cf8314cd815ef3..a803710c2e3bd1c65dcad5f03162ee304ab8cd62 100644 (file)
@@ -32,46 +32,66 @@ else
        exit 0
 fi
 
+[ -z "$HTTPD_MPM" ] && HTTPD_MPM="prefork"
+if   [ -d "${HTTPD_CONF:-'/etc/httpd/httpd.conf'}" ]; then
+       CFG="-f ${HTTPD_CONF:-'/etc/httpd/httpd.conf'}"
+elif [ -n "$HTTPD_CONF" ]; then
+       echo "error: HTTPD_CONF='$HTTPD_CONF': not a file, not a directory"
+       exit 1
+else
+       CFG=""
+fi
+
 RETVAL=0
 # See how we were called.
 case "$1" in
   start)
        # Check if the service is already running?
        if [ ! -f /var/lock/subsys/httpd ]; then
-               msg_starting httpd
-               daemon httpd $HTTPD_OPTS
+               msg_starting httpd.${HTTPD_MPM}
+               daemon httpd.${HTTPD_MPM} $CFG $HTTPD_OPTS
                RETVAL=$?
                [ $RETVAL -eq 0 ] && touch /var/lock/subsys/httpd
        else
-               msg_already_running httpd
+               msg_already_running httpd.${HTTPD_MPM}
        fi
        ;;
   stop)
        # Stop daemons.
        if [ -f /var/lock/subsys/httpd ]; then
-               msg_stopping httpd
-               daemon httpd -k stop
-               rm -f /var/lock/subsys/httpd /var/run/httpd.pid /var/run/httpd.loc* >/dev/null 2>&1
+               msg_stopping httpd.${HTTPD_MPM}
+               daemon --waitforname httpd.${HTTPD_MPM} --waitfortime 60 httpd.${HTTPD_MPM} $CFG -k stop
+               RET=$?
+               # Delete pidfile only when apache was called successfully
+               if [ $RET -eq 0 ]; then
+                       rm -f /var/lock/subsys/httpd /var/run/httpd.pid /var/run/httpd.loc* >/dev/null 2>&1
+               fi
        else
-               msg_not_running httpd
+               msg_not_running httpd.${HTTPD_MPM}
        fi
        ;;
   status)
-       status httpd
+       status httpd.${HTTPD_MPM}
        RETVAL=$?
-       /usr/sbin/httpd -S
+       /usr/sbin/httpd.${HTTPD_MPM} $CFG -S
        ;;
   restart)
-       $0 stop
+       $0 stop
        $0 start
        ;;
   reload|force-reload|graceful)
        if [ -f /var/lock/subsys/httpd ]; then
-               msg_reloading httpd
-               daemon httpd -k graceful
+               msg_reloading httpd.${HTTPD_MPM}
+               httpd.${HTTPD_MPM} $CFG -t > /dev/null 2>&1
+               if [ $? -eq 0 ]; then
+                   daemon httpd.${HTTPD_MPM} $CFG -k graceful
+               else
+                   fail
+                   echo "Configuration file syntax test failed."
+               fi
                RETVAL=$?
        else
-               msg_not_running httpd >&2
+               msg_not_running httpd.${HTTPD_MPM} >&2
                RETVAL=7
        fi
        ;;
This page took 0.03132 seconds and 4 git commands to generate.